package org.sonatype.nexus.plugin.staging;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on nexus-maven-plugin.<br/> Call <pre>  mvn nexus:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Jul 24 08:13:45 CDT 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.sonatype.plugins:nexus-maven-plugin:2.1", 0 );
        append( sb, "", 0 );

        append( sb, "Nexus : Maven Plugins : Nexus", 0 );
        append( sb, "Maven plugin used to interact with Nexus and Nexus Professional instances.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 9 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "nexus:help", 0 );
            append( sb, "Display help information on nexus-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0nexus:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "settings-download".equals( goal ) )
        {
            append( sb, "nexus:settings-download", 0 );
            append( sb, "Download a settings.xml template into the local maven instance. Settings can be saved to several locations:\n\n-\tdestination == global: Save to $maven.home/conf\n-\tdestination == user: Save to ~/.m2\n-\ttarget == /path/to/settings.xml: Save to /path/to/settings.xml\n\nAdditionally, by default any existing settings.xml file in the way will be backed up using a datestamp to ensure previous backup files are not overwritten.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "backupFormat (Default: yyyyMMdd_HHmmss)", 2 );
                append( sb, "When backing up an existing settings.xml file, use this date format in conjunction with SimpleDateFormat to construct a new filename of the form: settings.xml.$(format). Datestamps are used for backup copies of the settings.xml to avoid overwriting previously backed up settings files. This protects against the case where the download mojo is used multiple times with incorrect settings, where using a single static backup-file name would destroy the original, pre-existing settings.", 3 );
                append( sb, "Expression: ${backupFormat}", 3 );
                append( sb, "", 0 );

                append( sb, "destination (Default: user)", 2 );
                append( sb, "The standard destination where the downloaded settings.xml template should be saved. The target parameter will override this value.", 3 );
                append( sb, "Expression: ${destination}", 3 );
                append( sb, "", 0 );

                append( sb, "doBackup (Default: true)", 2 );
                append( sb, "If true and there is a pre-existing settings.xml file in the way of this download, backup the file to a datestamped filename, where the specific format of the datestamp is given by the backupFormat parameter.", 3 );
                append( sb, "Expression: ${doBackup}", 3 );
                append( sb, "", 0 );

                append( sb, "encoding", 2 );
                append( sb, "Use this parameter to define a non-default encoding for the settings file.", 3 );
                append( sb, "Expression: ${encoding}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "settingsDefaults (Default: ${user.home}/.m2/settings-defaults.properties)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${settings.defaults}", 3 );
                append( sb, "", 0 );

                append( sb, "target", 2 );
                append( sb, "If set, ignore the standard location given by the destination parameter, and use this file location to save the settings template instead. If this file exists, it will be backed up using the same logic as the standard locations (using the doBackup and backupFormat parameters).", 3 );
                append( sb, "Expression: ${target}", 3 );
                append( sb, "", 0 );

                append( sb, "templateId (Default: default)", 2 );
                append( sb, "The ID of the template to download. For instance, a templateId of \'sonatype\' will download from \'${nexusUrl}/service/local/templates/settings/sonatype/content\'.", 3 );
                append( sb, "Expression: ${settings.templateId}", 3 );
                append( sb, "", 0 );

                append( sb, "url", 2 );
                append( sb, "The full URL of a settings template available from a particular Nexus Professional instance. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${url}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-build-promotion".equals( goal ) )
        {
            append( sb, "nexus:staging-build-promotion", 0 );
            append( sb, "Promotes a set of closed Nexus staging repositories into a Nexus Build Promotion Profile.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "description (Default: Staging Promoting ${project.build.finalName})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryIds", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingBuildPromotionProfileId", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${stagingBuildPromotionProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-close".equals( goal ) )
        {
            append( sb, "nexus:staging-close", 0 );
            append( sb, "Closes a Nexus staging repository so it\'s become \'frozen\' and not receive deploys anymore. Optionally, it becomes available for use by Maven.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "artifactId (Default: ${project.artifactId})", 2 );
                append( sb, "The artifact artifactId used to select which open staging repository should be closed.", 3 );
                append( sb, "Expression: ${nexus.artifactId}", 3 );
                append( sb, "", 0 );

                append( sb, "auto (Default: false)", 2 );
                append( sb, "Deprecated. Use parameter \'automatic\' instead.", 3 );
                append( sb, "", 0 );
                append( sb, "If true, the mojo will simply select the first result from the list of open staging repositories that match the given groupId, artifactId, and version. Otherwise, the mojo will prompt the user for input.", 3 );
                append( sb, "Expression: ${auto}", 3 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "description (Default: Staging Closing ${project.build.finalName})", 2 );
                append( sb, "The description for the newly closed staging repository. This will show up in the Nexus UI.", 3 );
                append( sb, "Expression: ${nexus.description}", 3 );
                append( sb, "", 0 );

                append( sb, "dropOnFailure (Default: false)", 2 );
                append( sb, "If true, the mojo will try to remove the staging repository it was not able to close.", 3 );
                append( sb, "Expression: ${nexus.dropOnFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "groupId (Default: ${project.groupId})", 2 );
                append( sb, "The artifact groupId used to select which open staging repository should be closed.", 3 );
                append( sb, "Expression: ${nexus.groupId}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${project.version})", 2 );
                append( sb, "The artifact version used to select which open staging repository should be closed.", 3 );
                append( sb, "Expression: ${nexus.version}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-drop".equals( goal ) )
        {
            append( sb, "nexus:staging-drop", 0 );
            append( sb, "Drops a Nexus staging repository that is either open or closed.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "description (Default: Staging Dropping ${project.build.finalName})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "dropAutoSelectOverride (Default: false)", 2 );
                append( sb, "If set to true, allow auto-selection of the repository to drop in cases where no repositoryId has been specified during execution, and only one staged repository is available.\nNOTE: Use with care! This can be dangerous!", 3 );
                append( sb, "Expression: ${nexus.drop.autoSelectOverride}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-list".equals( goal ) )
        {
            append( sb, "nexus:staging-list", 0 );
            append( sb, "Lists all Nexus staging repositories available for a user. This goal lists both, \'opened\' and \'closed\' staging repositories.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-profiles-list".equals( goal ) )
        {
            append( sb, "nexus:staging-profiles-list", 0 );
            append( sb, "Lists all Nexus staging profiles available for a user.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-promote".equals( goal ) )
        {
            append( sb, "nexus:staging-promote", 0 );
            append( sb, "Promotes a set of closed Nexus staging repositories into a Nexus Build Promotion Profile.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "description (Default: Staging Promoting ${project.build.finalName})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryIds", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingBuildPromotionProfileId", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${stagingBuildPromotionProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "staging-release".equals( goal ) )
        {
            append( sb, "nexus:staging-release", 0 );
            append( sb, "Releases a single closed Nexus staging repository into a permanent Nexus repository for general consumption.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "automatic (Default: false)", 2 );
                append( sb, "If false, the Nexus discovery process will prompt the user to accept any Nexus connection information it finds before using it.\nNOTE: Batch-mode executions will override this parameter with an effective value of \'true\'.", 3 );
                append( sb, "Expression: ${nexus.automaticDiscovery}", 3 );
                append( sb, "", 0 );

                append( sb, "description (Default: Staging Releasing ${project.build.finalName})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.url}", 3 );
                append( sb, "", 0 );

                append( sb, "password", 2 );
                append( sb, "The password that should be used to log into Nexus. If missing, the mojo will prompt for this value.", 3 );
                append( sb, "Expression: ${nexus.password}", 3 );
                append( sb, "", 0 );

                append( sb, "promoteAutoSelectOverride (Default: false)", 2 );
                append( sb, "If set to true, allow auto-selection of the repository to promote in cases where no repositoryId has been specified during execution, and only one staged repository is available.\nNOTE: Use with care! This can be dangerous!", 3 );
                append( sb, "Expression: ${nexus.promote.autoSelectOverride}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryId", 2 );
                append( sb, "If provided, and this repository is available for selection, use it.", 3 );
                append( sb, "Expression: ${nexus.repositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "serverAuthId", 2 );
                append( sb, "If provided, lookup username/password from this server entry in the current Maven settings.", 3 );
                append( sb, "Expression: ${nexus.serverAuthId}", 3 );
                append( sb, "", 0 );

                append( sb, "targetRepositoryId", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${targetRepositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "userAgent", 2 );
                append( sb, "Filter opened staging repositories using the provided user agent", 3 );
                append( sb, "Expression: ${nexus.userAgent}", 3 );
                append( sb, "", 0 );

                append( sb, "username (Default: ${user.name})", 2 );
                append( sb, "The username that should be used to log into Nexus.", 3 );
                append( sb, "Expression: ${nexus.username}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
